diff --git a/drivers/iommu/iommufd/iommufd_test.h b/drivers/iommu/iommufd/iommufd_test.h
index fbf9ecb35a13..5c5d425243bb 100644
--- a/drivers/iommu/iommufd/iommufd_test.h
+++ b/drivers/iommu/iommufd/iommufd_test.h
@@ -265,4 +265,7 @@ struct iommu_viommu_event_selftest {
 	__u32 virt_id;
 };
 
+#define IOMMU_VQUEUE_TYPE_SELFTEST 0xdeadbeef
+#define IOMMU_TEST_VQUEUE_MAX 2
+
 #endif
diff --git a/tools/testing/selftests/iommu/iommufd_utils.h b/tools/testing/selftests/iommu/iommufd_utils.h
index a5d4cbd089ba..f8b52c76a166 100644
--- a/tools/testing/selftests/iommu/iommufd_utils.h
+++ b/tools/testing/selftests/iommu/iommufd_utils.h
@@ -956,6 +956,37 @@ static int _test_cmd_vdevice_alloc(int fd, __u32 viommu_id, __u32 idev_id,
 		     _test_cmd_vdevice_alloc(self->fd, viommu_id, idev_id,   \
 					     virt_id, vdev_id))
 
+static int _test_cmd_vqueue_alloc(int fd, __u32 viommu_id, __u32 type,
+				  __u32 idx, __u64 addr, __u64 length,
+				  __u32 *vqueue_id)
+{
+	struct iommu_vqueue_alloc cmd = {
+		.size = sizeof(cmd),
+		.viommu_id = viommu_id,
+		.type = type,
+		.index = idx,
+		.addr = addr,
+		.length = length,
+	};
+	int ret;
+
+	ret = ioctl(fd, IOMMU_VQUEUE_ALLOC, &cmd);
+	if (ret)
+		return ret;
+	if (vqueue_id)
+		*vqueue_id = cmd.out_vqueue_id;
+	return 0;
+}
+
+#define test_cmd_vqueue_alloc(viommu_id, type, idx, addr, len, vqueue_id)   \
+	ASSERT_EQ(0, _test_cmd_vqueue_alloc(self->fd, viommu_id, type, idx, \
+					    addr, len, vqueue_id))
+#define test_err_vqueue_alloc(_errno, viommu_id, type, idx, addr, len,      \
+			      vqueue_id)                                    \
+	EXPECT_ERRNO(_errno,                                                \
+		     _test_cmd_vqueue_alloc(self->fd, viommu_id, type, idx, \
+					    addr, len, vqueue_id))
+
 static int _test_cmd_veventq_alloc(int fd, __u32 viommu_id, __u32 type,
 				   __u32 *veventq_id, __u32 *veventq_fd)
 {
diff --git a/drivers/iommu/iommufd/selftest.c b/drivers/iommu/iommufd/selftest.c
index 033345f81df9..58ce1f6e50ba 100644
--- a/drivers/iommu/iommufd/selftest.c
+++ b/drivers/iommu/iommufd/selftest.c
@@ -148,6 +148,7 @@ to_mock_nested(struct iommu_domain *domain)
 struct mock_viommu {
 	struct iommufd_viommu core;
 	struct mock_iommu_domain *s2_parent;
+	struct mock_vqueue *mock_vqueue[IOMMU_TEST_VQUEUE_MAX];
 };
 
 static inline struct mock_viommu *to_mock_viommu(struct iommufd_viommu *viommu)
@@ -155,6 +156,18 @@ static inline struct mock_viommu *to_mock_viommu(struct iommufd_viommu *viommu)
 	return container_of(viommu, struct mock_viommu, core);
 }
 
+struct mock_vqueue {
+	struct iommufd_vqueue core;
+	struct mock_viommu *mock_viommu;
+	struct mock_vqueue *prev;
+	u16 index;
+};
+
+static inline struct mock_vqueue *to_mock_vqueue(struct iommufd_vqueue *vqueue)
+{
+	return container_of(vqueue, struct mock_vqueue, core);
+}
+
 enum selftest_obj_type {
 	TYPE_IDEV,
 };
@@ -727,10 +740,64 @@ static int mock_viommu_cache_invalidate(struct iommufd_viommu *viommu,
 	return rc;
 }
 
+/* Test iommufd_vqueue_depend/undepend() */
+static struct iommufd_vqueue *mock_vqueue_alloc(struct iommufd_viommu *viommu,
+						unsigned int type, u32 index,
+						dma_addr_t addr, size_t length)
+{
+	struct mock_viommu *mock_viommu = to_mock_viommu(viommu);
+	struct mock_vqueue *mock_vqueue, *prev = NULL;
+	int rc;
+
+	if (type != IOMMU_VQUEUE_TYPE_SELFTEST)
+		return ERR_PTR(-EOPNOTSUPP);
+	if (index >= IOMMU_TEST_VQUEUE_MAX)
+		return ERR_PTR(-EINVAL);
+	if (mock_viommu->mock_vqueue[index])
+		return ERR_PTR(-EEXIST);
+	if (index) {
+		prev = mock_viommu->mock_vqueue[index - 1];
+		if (!prev)
+			return ERR_PTR(-EIO);
+	}
+
+	mock_vqueue = iommufd_vqueue_alloc(viommu, struct mock_vqueue, core);
+	if (IS_ERR(mock_vqueue))
+		return ERR_CAST(mock_vqueue);
+
+	if (prev) {
+		rc = iommufd_vqueue_depend(mock_vqueue, prev, core);
+		if (rc)
+			goto free_vqueue;
+	}
+	mock_vqueue->prev = prev;
+	mock_vqueue->mock_viommu = mock_viommu;
+	mock_viommu->mock_vqueue[index] = mock_vqueue;
+
+	return &mock_vqueue->core;
+free_vqueue:
+	iommufd_struct_destroy(mock_vqueue, core);
+	return ERR_PTR(rc);
+}
+
+static void mock_vqueue_destroy(struct iommufd_vqueue *vqueue)
+{
+	struct mock_vqueue *mock_vqueue = to_mock_vqueue(vqueue);
+	struct mock_viommu *mock_viommu = mock_vqueue->mock_viommu;
+
+	mock_viommu->mock_vqueue[mock_vqueue->index] = NULL;
+	if (mock_vqueue->prev)
+		iommufd_vqueue_undepend(mock_vqueue, mock_vqueue->prev, core);
+
+	/* iommufd core frees mock_vqueue and vqueue */
+}
+
 static struct iommufd_viommu_ops mock_viommu_ops = {
 	.destroy = mock_viommu_destroy,
 	.alloc_domain_nested = mock_viommu_alloc_domain_nested,
 	.cache_invalidate = mock_viommu_cache_invalidate,
+	.vqueue_alloc = mock_vqueue_alloc,
+	.vqueue_destroy = mock_vqueue_destroy,
 };
 
 static struct iommufd_viommu *
diff --git a/tools/testing/selftests/iommu/iommufd.c b/tools/testing/selftests/iommu/iommufd.c
index 666a91d53195..5e81ccafd155 100644
--- a/tools/testing/selftests/iommu/iommufd.c
+++ b/tools/testing/selftests/iommu/iommufd.c
@@ -3031,6 +3031,65 @@ TEST_F(iommufd_viommu, vdevice_cache)
 	}
 }
 
+TEST_F(iommufd_viommu, vqueue)
+{
+	uint32_t viommu_id = self->viommu_id;
+	__u64 iova = MOCK_APERTURE_START;
+	uint32_t vqueue_id[2];
+
+	if (viommu_id) {
+		/* Fail IOMMU_VQUEUE_TYPE_DEFAULT */
+		test_err_vqueue_alloc(EOPNOTSUPP, viommu_id,
+				      IOMMU_VQUEUE_TYPE_DEFAULT, 0, iova,
+				      PAGE_SIZE, &vqueue_id[0]);
+		/* Fail queue addr and length */
+		test_err_vqueue_alloc(EINVAL, viommu_id,
+				      IOMMU_VQUEUE_TYPE_SELFTEST, 0, 0,
+				      PAGE_SIZE, &vqueue_id[0]);
+		test_err_vqueue_alloc(EINVAL, viommu_id,
+				      IOMMU_VQUEUE_TYPE_SELFTEST, 0, iova, 0,
+				      &vqueue_id[0]);
+		test_err_vqueue_alloc(EOVERFLOW, viommu_id,
+				      IOMMU_VQUEUE_TYPE_SELFTEST, 0,
+				      ~(uint64_t)0, PAGE_SIZE, &vqueue_id[0]);
+		/* Fail missing iova */
+		test_err_vqueue_alloc(ENXIO, viommu_id,
+				      IOMMU_VQUEUE_TYPE_SELFTEST, 0, iova,
+				      PAGE_SIZE, &vqueue_id[0]);
+
+		/* Map iova */
+		test_ioctl_ioas_map(buffer, PAGE_SIZE, &iova);
+
+		/* Fail index=1 and =MAX; must start from index=0 */
+		test_err_vqueue_alloc(EIO, viommu_id,
+				      IOMMU_VQUEUE_TYPE_SELFTEST, 1, iova,
+				      PAGE_SIZE, &vqueue_id[0]);
+		test_err_vqueue_alloc(EINVAL, viommu_id,
+				      IOMMU_VQUEUE_TYPE_SELFTEST,
+				      IOMMU_TEST_VQUEUE_MAX, iova, PAGE_SIZE,
+				      &vqueue_id[0]);
+
+		/* Allocate index=0 */
+		test_cmd_vqueue_alloc(viommu_id, IOMMU_VQUEUE_TYPE_SELFTEST, 0,
+				      iova, PAGE_SIZE, &vqueue_id[0]);
+		/* Fail duplicate */
+		test_err_vqueue_alloc(EEXIST, viommu_id,
+				      IOMMU_VQUEUE_TYPE_SELFTEST, 0, iova,
+				      PAGE_SIZE, &vqueue_id[0]);
+
+		/* Allocate index=1 */
+		test_cmd_vqueue_alloc(viommu_id, IOMMU_VQUEUE_TYPE_SELFTEST, 1,
+				      iova, PAGE_SIZE, &vqueue_id[1]);
+		/* Fail to destroy, due to dependency */
+		EXPECT_ERRNO(EBUSY,
+			     _test_ioctl_destroy(self->fd, vqueue_id[0]));
+
+		/* Destroy in descending order */
+		test_ioctl_destroy(vqueue_id[1]);
+		test_ioctl_destroy(vqueue_id[0]);
+	}
+}
+
 FIXTURE(iommufd_device_pasid)
 {
 	int fd;
diff --git a/tools/testing/selftests/iommu/iommufd_fail_nth.c b/tools/testing/selftests/iommu/iommufd_fail_nth.c
index f7ccf1822108..9b0ca43d7829 100644
--- a/tools/testing/selftests/iommu/iommufd_fail_nth.c
+++ b/tools/testing/selftests/iommu/iommufd_fail_nth.c
@@ -634,6 +634,7 @@ TEST_FAIL_NTH(basic_fail_nth, device)
 	uint32_t idev_id;
 	uint32_t hwpt_id;
 	uint32_t viommu_id;
+	uint32_t vqueue_id;
 	uint32_t vdev_id;
 	__u64 iova;
 
@@ -696,6 +697,11 @@ TEST_FAIL_NTH(basic_fail_nth, device)
 	if (_test_cmd_vdevice_alloc(self->fd, viommu_id, idev_id, 0, &vdev_id))
 		return -1;
 
+	if (_test_cmd_vqueue_alloc(self->fd, viommu_id,
+				   IOMMU_VQUEUE_TYPE_SELFTEST, 0, iova,
+				   PAGE_SIZE, &vqueue_id))
+		return -1;
+
 	if (_test_ioctl_fault_alloc(self->fd, &fault_id, &fault_fd))
 		return -1;
 	close(fault_fd);